<renderer name="stembuilder-element"
     tag="stembuilder-element"
     lang="javascript"
     onrender="javascript:stembuilder_element_render">
      
  <javascript name="stembuilder_element_render">
<![CDATA[

function stembuilder_element_render (renderer_node, node)
{
    element = node.attrib.element;
    title = node.attrib.title;

    if (title == "")
	title = element;

    xml = '<button name="' + element + '" onmousemotion="update_label" width="30" height="30" \
	   onclick="new_element" element="' + element + '" description="' + title + '"> \
	   <image src="images/' + element + '.xpm"/> </button>';
    
    node.append_xml (xml);
}

]]>
  </javascript>
  
</renderer>

<window name="elements" title="StemBuilder Elements" 
 dialog="true" width="485" height="112">
	    <hwrapalign expand="true">
	        <button name="newapp" description="New Application" 
		 onclick="new_application"
		 element="$element"
		 onmousemotion="update_label"
		 width="30" height="30">
		  <image src="images/newapp.xpm"/>
		</button>
		<stembuilder-element important="dragable" title="Object" element="object"/>
		<stembuilder-element important="border,title,position,ondelete,dialog" title="Window" element="window"/>
		<stembuilder-element important="title,onselect,oncancel" title="File Selection Dialog" element="filesel"/>
		<stembuilder-element important="interval,action" title="Timer" element="timer"/>
		<stembuilder-element important="border,spacing,homogenous" title="Vertical Alignment" element="valign"/>
		<stembuilder-element important="border,spacing,homogenous" title="Horizontal Alignment" element="halign"/>
		<stembuilder-element important="hspacing,vspacing,border" title="Vertical Wrap Alignment" element="vwrapalign"/>
		<stembuilder-element important="hspacing,vspacing,border" title="Horizontal Wrap Alignment" element="hwrapalign"/>
		<stembuilder-element important="title,border" title="Frame" element="frame"/>
		<stembuilder-element important="border" title="Fixed" element="fixed"/>
		<stembuilder-element important="border,y-scroll,x-scroll" title="Scrolled Window" element="scrollwindow"/>
		<stembuilder-element important="border" title="Note Book" element="notebook"/>
		<stembuilder-element important="title" title="Note Book Page" element="notepage"/>
		<stembuilder-element title="Horizontal Pane" element="hpane"/>
		<stembuilder-element title="Vertical Pane" element="vpane"/>
		<stembuilder-element title="Horizontal Separator" element="hseparator"/>
		<stembuilder-element title="Vertical Separator" element="vseparator"/>
		<stembuilder-element important="label,tooltip,onclick" title="Button" element="button"/>
		<stembuilder-element important="selected,label,tooltip,onclick" title="Toggle Button" element="togglebutton"/>
		<stembuilder-element important="onselect" title="Radio Button Group" element="radio-group"/>
		<stembuilder-element important="onselect,tooltip,value,selected,label" title="Radio Button" element="radio"/>
		<stembuilder-element important="selected,value,label,tooltip,onselect" title="CheckBox Button" element="checkbox"/>
		<stembuilder-element important="onchange,onenter,editable,text" title="1 Line Entry" element="entry"/>
		<stembuilder-element important="editable" title="Text Entry/Viewer" element="text"/>
		<stembuilder-element title="Menu Bar" element="menubar"/>
		<stembuilder-element title="Option Menu" element="optionmenu"/>
		<stembuilder-element important="label" title="Menu" element="menu"/>
		<stembuilder-element important="label,onselect" title="Menu Item" element="menuitem"/>
		<stembuilder-element important="xpad,ypad,xalign,yalign,justify,text" title="Label" element="label"/>
		<stembuilder-element title="Progress Meter" element="progress"/>
		<stembuilder-element important="editable,float,tooltip,places,step,min,max" title="Number Spinner" element="spinner"/>
		<stembuilder-element important="onexpand,onselect,,show-titles,spacing,indent,selection-type"
		 title="Columned Tree" element="ctree"/>
		<stembuilder-element important="title,width,resizeable,active,auto-resize" 
		 title="Column Definition for Columned Tree" element="ctree-column"/>
		<stembuilder-element important="selected,onselect,onbuttonpress" 
		 title="Columned Tree Row" element="ctree-row"/>
		<stembuilder-element important="text,image" title="Columned Tree Cell" element="ctree-cell"/>
		<stembuilder-element important="text,onopen,onenter,editable" title="Dropdown Menu" element="dropdown"/>
		<stembuilder-element important="text" title="String" element="string"/>
		<stembuilder-element title="Tree (Toplevel and Node)" element="tree"/>
		<stembuilder-element title="List (Toplevel and Node)" element="list"/>
		<stembuilder-element title="Perl" element="perl"/>
		<stembuilder-element title="Python" element="python"/>
		<stembuilder-element title="TCL" element="tcl"/>
		<stembuilder-element title="JavaScript" element="javascript"/>
	    </hwrapalign>
	    <halign>
	      <label name="tool_description" text=""/>
	    </halign>
</window>


